﻿BrokerControl = LibStub("AceAddon-3.0"):NewAddon("Broker_Control", "AceEvent-3.0", "AceTimer-3.0")
local ldb = LibStub:GetLibrary("LibDataBroker-1.1")
local QTC = LibStub('LibQTip-1.0')
local C = LibStub("AceConfigDialog-3.0")

local mod = BrokerControl

local L = LibStub("AceLocale-3.0"):NewLocale("Broker_Control", "enUS", true)
	
if L then
	L["|c000070ddClick:|r |c0000FF00Readycheck.|r\n|c000070ddAlt-Click:|r |c0000FF00Set Icons.|r\n|c000070ddShift-Click:|r |c0000FF00Convert to raid.|r"] = true
	L["10 Player (Heroic)"] = true
	L["10 Player"] = true
	L["25 Player (Heroic)"] = true
	L["25 Player"] = true
	L["5 Player (Heroic)"] = true
	L["5 Player"] = true
	L["Add Target"] = true
	L["Clear Targets"] = true
	L["Dev Mode"] = true
	L["Epic"] = true
	L["Free for all"] = true
	L["Friendly Icons"] = true
	L["Group Loot"] = true
	L["HighestPriority"] = true
	L["Hostile Icons"] = true
	L["Icon check delay"] = true
	L["Icon Priorities"] = true
	L["Loot Mode"] = true
	L["Loot Threshold"] = true
	L["LowestPriority"] = true
	L["Master Loot"] = true
	L["Max tooltip height"] = true
	L["Maximum height of tooltip before a scrollframe is used. 0 for no scrollframe."] = true
	L["Group Difficulty"] = true
	L["Raid Difficulty"] = true
	L["Rare"] = true
	L["Show text"] = true
	L["|c00ff0000Not Promoted|r"] = true
	L["Time between icon reapplication."] = true
	L["Uncommon"] = true
	L["oRA2 Tanks"] = true
	L["Show and send oRA3 tanks to oRA2"] = true
	L["Clear Tanks"] = true
	L["Broadcast Tanks"] = true
end

local L = LibStub("AceLocale-3.0"):NewLocale("Broker_Control", "koKR")
	
if L then
	L["10 Player"] = "10 인"
L["10 Player (Heroic)"] = "10 인 (영웅)"
L["25 Player"] = "25 인"
L["25 Player (Heroic)"] = "25 인 (영웅)"
L["5 Player"] = "5 인"
L["5 Player (Heroic)"] = "5 인 (영웅)"
L["Add Target"] = "대상 추가"
L[ [=[|c000070ddClick:|r |c0000FF00Readycheck.|r
|c000070ddAlt-Click:|r |c0000FF00Set Icons.|r
|c000070ddShift-Click:|r |c0000FF00Convert to raid.|r]=] ] = [=[|c000070ddClick:|r |c0000FF00전투 준비.|r
|c000070ddAlt-Click:|r |c0000FF00아이론 설정.|r
|c000070ddShift-Click:|r |c0000FF00Convert to raid.|r]=]
L["|c00ff0000Not Promoted|r"] = "|c00ff0000승급 안됨|r"
L["Clear Targets"] = "대상 지우기"
L["Epic"] = "영웅"
L["Free for all"] = "자유 획득"
L["Group Difficulty"] = "던전 난이도"
L["Group Loot"] = "주사위 굴림"
L["Loot Mode"] = "아이템 획득 방식"
L["Loot Threshold"] = "전리품 분배 조건"
L["Master Loot"] = "담당자 획득"
L["Max tooltip height"] = "최대 툴팁 높이"
L["Raid Difficulty"] = "공격대 난이도"
L["Rare"] = "희귀"
L["Show text"] = "텍스트 보기"
L["Uncommon"] = "고급"

end

local L = LibStub("AceLocale-3.0"):GetLocale("Broker_Control")

local actualmethod = {"master", "group", "freeforall"}
local checkBox = "|TInterface\\Buttons\\UI-CheckBox-Check:20|t"
local ClassTable = {}
local db
local Difficulty
local format = string.format
local ISPROMOTED
local TempTanks = {}
local NewTanks = {}
local LootColors = {"|c001eff00", "|c000080ff", "|c00b048f8"}
local LootThreshold = {L["Uncommon"], L["Rare"], L["Epic"]}
local LootTypeColors = {"|c00b048f8", "|c000080ff", "|c00ffffff"}
local LootTypes = {L["Master Loot"], L["Group Loot"], L["Free for all"]}
local PartySetText = {L["5 Player"], L["5 Player (Heroic)"]}
local PartyText = {"5N", "5H"}
local Player = UnitName("player")
local RaidIconFormat = "|TInterface\\TargetingFrame\\UI-RaidTargetingIcon_%s:20:20|t"
local RaidSetText = {L["10 Player"], L["25 Player"], L["10 Player (Heroic)"], L["25 Player (Heroic)"]}
local RaidText = {"10N", "25N", "10H", "25H"}
local TIMERNEEDED
local LISTENING
local tinsert = table.insert
local tremove = table.remove
local UIMinus = "|TInterface\\Buttons\\UI-MinusButton-Up:20:20:1:0|t"
local UIPlus = "|TInterface\\Buttons\\UI-PlusButton-Up:20:20:1:0|t"
local IconPriorityText = {			
		L["HighestPriority"],
		"---------",
		"-----",
		"-",
		"-",
		"-----",
		"---------",
		L["LowestPriority"]
}

local defaults = {
	char = {
		devmode = nil,
		expandtanks = true,
		showtext = true,
		showdiff = true,
		showthresh = true,
		showtype = true,
		showprio = true,
		showfriendly = true,
		showhostile = true,
		showora2tanks = nil,
		iconpriority = {[1] = 8, [2] = 7, [3] = 2, [4] = 1, [5] = 3, [6] = 4, [7] = 5, [8] = 6},
		friendlytargets = {},
		hostiletargets = {},
		ora2tanks = {},
		maxheight = 0,
		timedelay = 10,
	}
}

local options = {
	name = "Broker_Control",
	handler = mod,
	type = "group",
	args = { 
		dev = {
			type = "toggle",
			name = L["Dev Mode"],
			get = function() return mod.db.char.devmode end,
			set = function(info, v) mod.db.char.devmode = v end,
			order = 5
		},
		stext = {
			type = "toggle",
			name = L["Show text"],
			get = function() return mod.db.char.showtext end,
			set = function(info, v) mod.db.char.showtext = v mod:UpdateBrokerText() end,
			order = 10
		},
		tanks = {
			type = "toggle",
			name = L["oRA2 Tanks"],
			desc = L["Show and send oRA3 tanks to oRA2"],
			get = function() return mod.db.char.showora2tanks end,
			set = function(info, v) mod.db.char.showora2tanks = v mod:ToggleAddonMessages() end,
			order = 12
		},
		height = {
			type = "range",
			name = L["Max tooltip height"],
			desc = L["Maximum height of tooltip before a scrollframe is used. 0 for no scrollframe."],
			get = function() return mod.db.char.maxheight end,
			set = 	function(info, v) mod.db.char.maxheight = v mod:UpdateBrokerText() end,
			min = 0, 
			max = 1500, 
			step = 25,
			order = 15
		},
		delay = {
			type = "range",
			name = L["Icon check delay"],
			desc = L["Time between icon reapplication."],
			get = function() return mod.db.char.timedelay end,
			set = 	function(info, v) mod.db.char.timedelay = v end,
			min = 1, 
			max = 60, 
			step = 1,
			order = 20
		},
	}
}
		

function mod:OnInitialize()
	self.db = LibStub("AceDB-3.0"):New("BrokerControlDB", defaults)
	self:CreateLDBObject()
	
	LibStub("AceConfig-3.0"):RegisterOptionsTable("Broker_Control", options)
	self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("Broker_Control", "Broker_Control")
end

function mod:OnEnable()
	db = mod.db.char
		
	self:RegisterEvent("PLAYER_REGEN_DISABLED")
	self:RegisterEvent("PLAYER_REGEN_ENABLED")
	self:RegisterEvent("RAID_ROSTER_UPDATE")
	self:RegisterEvent("PARTY_LOOT_METHOD_CHANGED")
	self:RegisterEvent("PARTY_MEMBERS_CHANGED")
	self:RegisterEvent("PLAYER_ENTERING_WORLD")
	
	self.Classcolors = {}
	self:SetupClasses()
	self:CheckTimer()
	
	self:ToggleAddonMessages()
end

function mod:OnDisable()
	self:CancelAllTimers() 
end

function mod:debug(message)
	if db.devmode then
		DEFAULT_CHAT_FRAME:AddMessage(message)
	end
end

function mod:ToggleAddonMessages()
	if oRA and db.showora2tanks and self:InRaid() and (self:IsLeader() or self:IsPromoted()) then
		if not LISTENING then
			self:debug("Listening to addons messages")
			self:RegisterEvent("CHAT_MSG_ADDON")
			LISTENING = true
		end
	else
		if LISTENING then
			self:UnregisterEvent("CHAT_MSG_ADDON") 
			self:debug("Not listening to addons messages")
			LISTENING = nil
		end
	end
end

function mod:SetupClasses()
	for class, color in pairs(CUSTOM_CLASS_COLORS or RAID_CLASS_COLORS) do
		mod.Classcolors[class] = mod:GetClassHexColour(class)
	end
	if CUSTOM_CLASS_COLORS then
		CUSTOM_CLASS_COLORS:RegisterCallback(function()
        		for class, color in pairs(CUSTOM_CLASS_COLORS) do
               			mod.Classcolors[class] = mod:GetClassHexColour(class)
          		end
        	end)
	end
end

function mod:GetClassHexColour(class)
	if (CUSTOM_CLASS_COLORS and CUSTOM_CLASS_COLORS[class]) then
		return "|c00" .. string.format("%02x%02x%02x", CUSTOM_CLASS_COLORS[class].r*255, CUSTOM_CLASS_COLORS[class].g*255, CUSTOM_CLASS_COLORS[class].b*255)
	elseif (RAID_CLASS_COLORS and RAID_CLASS_COLORS[class]) then
		return "|c00" .. string.format("%02x%02x%02x", RAID_CLASS_COLORS[class].r*255, RAID_CLASS_COLORS[class].g*255, RAID_CLASS_COLORS[class].b*255)
	else
		return "a1a1a1"
	end
end

function mod:CheckTimer()
	if self:TimerNeeded(db.friendlytargets) or self:TimerNeeded(db.hostiletargets) then
		self:debug("Need timer")
		TIMERNEEDED = true
	else TIMERNEEDED = nil
	end
end

function mod:TimerNeeded(table)
	for i = 1,8 do
		if table[i] then return true end
	end
	return false
end

function mod:PLAYER_REGEN_DISABLED()
	if TIMERNEEDED and ISPROMOTED and not self.combattimer then 
		self.combattimer = self:ScheduleRepeatingTimer("CheckIcons", db.timedelay)
		self:debug("Started timer")
		self:CheckIcons()
	end
end

function mod:PLAYER_REGEN_ENABLED()
	if TIMERNEEDED and self.combattimer then 
		self:CancelTimer(self.combattimer, true)
		self.combattimer = nil
		self:debug("Stopped timer")
	end
end

function mod:RAID_ROSTER_UPDATE()
	Difficulty = self:GetDifficulty()
	self:ToggleAddonMessages()
	self:UpdateBrokerText()
end

function mod:PARTY_LOOT_METHOD_CHANGED()
	if self.tooltip then self.tooltip:Clear() end
	self:DisplayTooltip()
end

function mod:PARTY_MEMBERS_CHANGED()
	if TIMERNEEDED then
		if self:IsPromoted() or self:IsLeader() or not self:InRaid() then ISPROMOTED = true
		else ISPROMOTED = nil end
	end
	Difficulty = self:GetDifficulty()
	self:UpdateBrokerText()
end

function mod:PLAYER_ENTERING_WORLD()
	self:PARTY_MEMBERS_CHANGED()
end

function mod:CHAT_MSG_ADDON(_, prefix, msg, type, author)
	if (prefix ~= "CTRA" and prefix ~= "oRA") then return end
	local action, arg1, arg2 = strsplit(" ", msg)
	if action == "SET" then
		self:AddTank(tonumber(arg1), arg2)
	elseif action == "R" then
		self:RemoveTank(nil, arg1)
	end
end

function mod:GetDifficulty()
	local _, _, difficultyIndex, _, maxPlayers, dynamicHeroic, isDynamic = GetInstanceInfo()
	if maxPlayers == 0 then return (self:InRaid() and GetRaidDifficulty()) or GetDungeonDifficulty()
	else return (isDynamic and (2-(difficultyIndex%2)+2*dynamicHeroic)) or difficultyIndex
	end
end

function mod:CreateLDBObject()
	mod.obj = ldb:NewDataObject("Broker_Control", {
		type = "data source",
		icon = "Interface\\Icons\\Ability_Rogue_FindWeakness.png",
		label = "Broker_Control",
		text = "",
		OnClick = function(frame, button)
				if button == "RightButton" then
					if not C.OpenFrames["Broker_Control"] then C:Open("Broker_Control") 
					else C:Close("Broker_Control") end
				else 
					if IsShiftKeyDown() then ConvertToRaid()
					elseif IsAltKeyDown() then mod:CheckIcons()
					else DoReadyCheck() end
				end
			end,
		OnEnter = function(frame)
				if mod.tooltip then mod:HideTooltip() end
				local tooltip = QTC:Acquire("Broker_ControlTooltip", 2, "LEFT", "LEFT")
				tooltip:Clear()
				tooltip:SmartAnchorTo(frame)
				tooltip:SetScript("OnLeave", mod.HideTooltip)
				tooltip:SetScript("OnUpdate", function(f) if not MouseIsOver(frame) then mod:HideTooltip() end end)
				mod.tooltip = tooltip
				mod:DisplayTooltip()
			end,
		OnLeave = function()
				mod:HideTooltip()
			end,
	})

end

function mod:HideTooltip(force)
	if self.tooltip then
		if MouseIsOver(self.tooltip) and not force then return end
		self.tooltip:SetScript("OnLeave", nil)
		self.tooltip:SetScript("OnUpdate", nil)
		self.tooltip:Hide()
		QTC:Release(self.tooltip)
		self.tooltip = nil
	end
end

function mod:UpdateBrokerText()
	if db.showtext then
		local text
		local threshold = GetLootThreshold()
		if self:InRaid() then 
			text = LootColors[threshold - 1] .. RaidText[Difficulty] .. "|r"
		elseif self:InParty() then 
			text = LootColors[threshold - 1] .. PartyText[Difficulty] .. "|r"
		else text = ""
		end
		mod.obj.text = text
	else mod.obj.text = ""
	end
end

function mod:InParty()
	if GetNumPartyMembers() > 0 then return true end
	return false
end

function mod:InRaid()
	return UnitInRaid("player") 
end

function mod:IsLeader()
	return IsRaidLeader()
end

function mod:IsPromoted()
	return IsRaidOfficer() 
end

function mod:IsPartyLeader()
	return IsPartyLeader()
end

function mod:UnitInGroup(unit)
	return UnitInParty(unit) or UnitInRaid(unit)
end

function mod:DisplayTooltip()
	local tooltip = mod.tooltip
	self:UpdateBrokerText()
	if not tooltip then return end
	
	local threshold = GetLootThreshold()
	local lootmethod = GetLootMethod()
	
	if self:IsLeader() and self:InRaid() then
		local y, x = tooltip:AddLine()
		if db.showdiff then
			tooltip:SetCell(y, x, UIMinus .. "|c0000FF00" .. L["Raid Difficulty"] .. "|r", nil, "LEFT", 2)
			tooltip:SetLineScript(y, "OnMouseDown", mod.HandleTTClick, {"showdiff"})
			for id, text in ipairs(RaidSetText) do
				local y, x = tooltip:AddLine()
				if id == Difficulty then tooltip:SetCell(y, 1, checkBox) 
				else tooltip:SetLineScript(y, "OnMouseDown", mod.HandleTTClick, {"Raid", id}) 
				end
				tooltip:SetCell(y, 2, "|c00FFFFFF" .. text .. "|r", nil, "LEFT")
			end
		else
			tooltip:SetCell(y, x, UIPlus .. "|c0000FF00" .. L["Raid Difficulty"] .. "|r", nil, "LEFT", 2)
			tooltip:SetLineScript(y, "OnMouseDown", mod.HandleTTClick, {"showdiff"})
		end
		tooltip:AddLine(" ")
	elseif self:IsPartyLeader() then
		local y, x = tooltip:AddLine()
		if db.showdiff then
			tooltip:SetCell(y, x, UIMinus .. "|c0000FF00" .. L["Group Difficulty"] .. "|r", nil, "LEFT", 2)
			tooltip:SetLineScript(y, "OnMouseDown", mod.HandleTTClick, {"showdiff"})
			for id, text in ipairs(PartySetText) do
				local y, x = tooltip:AddLine()
				if id == Difficulty then tooltip:SetCell(y, 1, checkBox) 
				else tooltip:SetLineScript(y, "OnMouseDown", mod.HandleTTClick, {"Party", id}) 
				end
				tooltip:SetCell(y, 2, "|c00FFFFFF" .. text .. "|r", nil, "LEFT")
			end
		else
			tooltip:SetCell(y, x, UIPlus .. "|c0000FF00" .. L["Group Difficulty"] .. "|r", nil, "LEFT", 2)
			tooltip:SetLineScript(y, "OnMouseDown", mod.HandleTTClick, {"showdiff"})
		end
		tooltip:AddLine(" ")
	end
	if self:IsLeader() or self:IsPartyLeader() then
		local y, x = tooltip:AddLine()
		if db.showthresh then
			tooltip:SetCell(y, x, UIMinus .. "|c0000FF00" .. L["Loot Threshold"] .. "|r", nil, "LEFT", 2)
			tooltip:SetLineScript(y, "OnMouseDown", mod.HandleTTClick, {"showthresh"})
			for id, text in ipairs(LootThreshold) do
				local y, x = tooltip:AddLine()
				if id == threshold - 1 then tooltip:SetCell(y, 1, checkBox) 
				else tooltip:SetLineScript(y, "OnMouseDown", mod.HandleTTClick, {"Loot", id + 1}) 
				end
				tooltip:SetCell(y, 2, LootColors[id] .. text .. "|r", nil, "LEFT")
			end
		else
			tooltip:SetCell(y, x, UIPlus .. "|c0000FF00" .. L["Loot Threshold"] .. "|r", nil, "LEFT", 2)
			tooltip:SetLineScript(y, "OnMouseDown", mod.HandleTTClick, {"showthresh"})
			
		end
		tooltip:AddLine(" ")
		local y, x = tooltip:AddLine()
		if db.showtype then
			tooltip:SetCell(y, x, UIMinus .. "|c0000FF00" .. L["Loot Mode"] .. "|r", nil, "LEFT", 2)
			tooltip:SetLineScript(y, "OnMouseDown", mod.HandleTTClick, {"showtype"})
			for id, text in ipairs(LootTypes) do
				local y, x = tooltip:AddLine()
				if actualmethod[id] == lootmethod then tooltip:SetCell(y, 1, checkBox) 
				else tooltip:SetLineScript(y, "OnMouseDown", mod.HandleTTClick, {"Type", id}) 
				end
				tooltip:SetCell(y, 2, LootTypeColors[id] .. text .. "|r", nil, "LEFT")
			end
		else
			tooltip:SetCell(y, x, UIPlus .. "|c0000FF00" .. L["Loot Mode"] .. "|r", nil, "LEFT", 2)
			tooltip:SetLineScript(y, "OnMouseDown", mod.HandleTTClick, {"showtype"})
			
		end
		tooltip:AddLine(" ")
	end
	local y, x = tooltip:AddLine()
	if db.showprio then
		tooltip:SetCell(y, x, UIMinus .. "|c0000FF00" .. L["Icon Priorities"] .. "|r", nil, "LEFT", 2)
		tooltip:SetLineScript(y, "OnMouseDown", mod.HandleTTClick, {"showprio"})
		for icon = 1,8 do
			local y, x = tooltip:AddLine()
			tooltip:SetCell(y, 1, format(RaidIconFormat, db.iconpriority[icon]))
			tooltip:SetCell(y, 2, IconPriorityText[icon], nil, "LEFT")
			tooltip:SetLineScript(y, "OnMouseDown", mod.HandleTTClick, {"IconPrio", icon}) 
		end
	else
		tooltip:SetCell(y, x, UIPlus .. "|c0000FF00" .. L["Icon Priorities"] .. "|r", nil, "LEFT", 2)
		tooltip:SetLineScript(y, "OnMouseDown", mod.HandleTTClick, {"showprio"})
	end
	if oRA and db.showora2tanks and (self:IsPromoted() or self:IsLeader()) then
		tooltip:AddLine(" ")
		local y, x = tooltip:AddLine()
		if db.expandtanks then
			tooltip:SetCell(y, x, UIMinus .. "|c0000FF00" .. L["oRA2 Tanks"] .. "|r", nil, "LEFT", 2)
			tooltip:SetLineScript(y, "OnMouseDown", mod.HandleTTClick, {"showtanks"})
			for tank = 1, 8 do
				local y, x = tooltip:AddLine()
				local text = "------------------"
				if db.ora2tanks[tank] then text = self:FormatName(db.ora2tanks[tank]) end
				tooltip:SetCell(y, 1, tank)
				tooltip:SetCell(y, 2, text, nil, "LEFT")
				tooltip:SetLineScript(y, "OnMouseDown", mod.HandleTTClick, {"changetank", tank}) 
			end
			local y, x = tooltip:AddLine()
			tooltip:SetCell(y, 2, L["Clear Tanks"], nil, "LEFT")
			tooltip:SetLineScript(y, "OnMouseDown", mod.HandleTTClick, {"Cleartanks"}) 
			local y, x = tooltip:AddLine()
			tooltip:SetCell(y, 2, L["Broadcast Tanks"], nil, "LEFT")
			tooltip:SetLineScript(y, "OnMouseDown", mod.HandleTTClick, {"Broadcasttanks"}) 
		else
			tooltip:SetCell(y, x, UIPlus .. "|c0000FF00" .. L["oRA2 Tanks"] .. "|r", nil, "LEFT", 2)
			tooltip:SetLineScript(y, "OnMouseDown", mod.HandleTTClick, {"showtanks"})
		end
	end
	tooltip:AddLine(" ")
	local y, x = tooltip:AddLine()
	if self:IsPromoted() or self:IsLeader() or (not self:InRaid() and self:InParty()) then
		if db.showfriendly then
			tooltip:SetCell(y, x, UIMinus .. "|c0000FF00" .. L["Friendly Icons"] .. "|r", nil, "LEFT", 2)
			tooltip:SetLineScript(y, "OnMouseDown", mod.HandleTTClick, {"showfriendly"})
			for icon = 1,8 do
				local y, x = tooltip:AddLine()
				local text = self:FormatName(db.friendlytargets[icon])
        			tooltip:SetCell(y, 1, format(RaidIconFormat, icon))
				tooltip:SetCell(y, 2, text, nil, "LEFT")
				tooltip:SetLineScript(y, "OnMouseDown", mod.HandleTTClick, {"IconFriendly", icon}) 
			end
			local y, x = tooltip:AddLine()
			tooltip:SetCell(y, 2, L["Clear Targets"], nil, "LEFT")
			tooltip:SetLineScript(y, "OnMouseDown", mod.HandleTTClick, {"ClearFriendly"}) 
		else
			tooltip:SetCell(y, x, UIPlus .. "|c0000FF00" .. L["Friendly Icons"] .. "|r", nil, "LEFT", 2)
			tooltip:SetLineScript(y, "OnMouseDown", mod.HandleTTClick, {"showfriendly"})
		end
		tooltip:AddLine(" ")
		local y, x = tooltip:AddLine()
		if db.showhostile then
			tooltip:SetCell(y, x, UIMinus .. "|c0000FF00" .. L["Hostile Icons"] .. "|r", nil, "LEFT", 2)
			tooltip:SetLineScript(y, "OnMouseDown", mod.HandleTTClick, {"showhostile"})
			for icon = 1,8 do
				local y, x = tooltip:AddLine()
				local text = self:FormatName(db.hostiletargets[icon])
        			tooltip:SetCell(y, 1, format(RaidIconFormat, icon))
				tooltip:SetCell(y, 2, text, nil, "LEFT")
				tooltip:SetLineScript(y, "OnMouseDown", mod.HandleTTClick, {"IconHostile", icon}) 
			end
			local y, x = tooltip:AddLine()
			tooltip:SetCell(y, 2, L["Clear Targets"], nil, "LEFT")
			tooltip:SetLineScript(y, "OnMouseDown", mod.HandleTTClick, {"ClearHostile"}) 
		else
			tooltip:SetCell(y, x, UIPlus .. "|c0000FF00" .. L["Hostile Icons"] .. "|r", nil, "LEFT", 2)
			tooltip:SetLineScript(y, "OnMouseDown", mod.HandleTTClick, {"showhostile"})
		end
		tooltip:AddLine(" ")
		local y, x = tooltip:AddLine()
		tooltip:SetCell(y, x, L["|c000070ddClick:|r |c0000FF00Readycheck.|r\n|c000070ddAlt-Click:|r |c0000FF00Set Icons.|r\n|c000070ddShift-Click:|r |c0000FF00Convert to raid.|r"], nil, "CENTER", 2, QTC.LabelProvider)      
      	else
      		local y, x = tooltip:AddLine()
		tooltip:SetCell(y, x, L["|c00ff0000Not Promoted|r"], nil, "CENTER", 2, QTC.LabelProvider)      
       	end
	
	if db.maxheight ~= 0 then 
        	tooltip:UpdateScrolling(db.maxheight)
        end
        tooltip:Show()
end

function mod:HandleTTClick(data, button)
	if not data then return end
	local command = data[1]
	local id = data[2]
	
	if command == "showdiff" then db.showdiff = not db.showdiff
        elseif command == "showthresh" then db.showthresh = not db.showthresh
        elseif command == "showprio" then db.showprio = not db.showprio
        elseif command == "showtype" then db.showtype = not db.showtype
        elseif command == "showfriendly" then db.showfriendly = not db.showfriendly
        elseif command == "showhostile" then db.showhostile = not db.showhostile
	elseif command == "showtanks" then db.expandtanks = not db.expandtanks
       	elseif command == "Raid" and id then SetRaidDifficulty(id)
        elseif command == "Party" and id then SetDungeonDifficulty(id)
        elseif command == "Loot" and id then SetLootThreshold(id)
        elseif command == "Type" and id then SetLootMethod(actualmethod[id], Player)
        elseif command == "IconPrio" and id then 
        	local movevalue = db.iconpriority[id]
        	if button == "LeftButton" then		--move prio up
        		tremove(db.iconpriority, id)
        		if id == 1 then id = 9 end
        		tinsert(db.iconpriority, id - 1, movevalue)
        	elseif button == "RightButton" then	--move prio down
        		tremove(db.iconpriority, id)
        		if id == 8 then id = 0 end
        		tinsert(db.iconpriority, id + 1, movevalue)
        	end
        elseif command == "IconFriendly" and id then 
        	if button == "RightButton" then	
        		db.friendlytargets[id] = nil 
        	else
        		if not mod:UnitInGroup("target") or mod:IconAlreadyAssigned(db.hostiletargets, id) then return end
        		local target = UnitName("target")
        		mod:RemoveDuplicateUnit(target, db.friendlytargets)
        		db.friendlytargets[id] = target
        	end
        	mod:CheckTimer()
        elseif command == "IconHostile" and id then 
        	if button == "RightButton" then	
        		db.hostiletargets[id] = nil 
        	else
        		if not mod:UnitInGroup("target") or mod:IconAlreadyAssigned(db.friendlytargets, id) then return end
        		local target = UnitName("target")
        		mod:RemoveDuplicateUnit(target, db.hostiletargets)
        		db.hostiletargets[id] = target	
        	end
        	mod:CheckTimer()
        elseif command == "ClearFriendly" then 
        	mod:ClearAllIcons(db.friendlytargets)
        	db.friendlytargets = {}
        	mod:CheckTimer()
        elseif command == "ClearHostile" then 
        	db.hostiletargets = {}
        	mod:CheckTimer()
        elseif command == "changetank" and id then 
        	if button == "RightButton" then	
        		if db.ora2tanks[id] then
        			mod:SendoRA2Message("R ".. db.ora2tanks[id])
        			mod:RemoveTank(id)
        		end
        	else
        		if not mod:UnitInGroup("target") then return end
        		local target = UnitName("target")
        		mod:AddTank(id, target)
        		mod:SendoRA2Message("SET " .. id .. " " .. target)
        	end
        elseif command == "Cleartanks" then 
        	mod:ClearAllTanks()        	
        elseif command == "Broadcasttanks" then 
        	mod:BroadcastTanks()        	
        end
        Difficulty = mod:GetDifficulty()
        mod.tooltip:Clear()
	mod:DisplayTooltip()
end

function mod:RemoveDuplicateUnit(unit, table)
	for index, name in pairs(table) do
		if name == unit then 
			table[index] = nil
			return
		end
	end
end

function mod:RemoveDuplicateTank(unit)
	for index, name in pairs(db.ora2tanks) do
		if name == unit then 
			db.ora2tanks[index] = nil
			return
		end
	end
end

function mod:AddTank(index, name)
	mod:RemoveDuplicateTank(name)
        db.ora2tanks[index] = name
        		
end

function mod:RemoveTank(index, name)
	if index then
		db.ora2tanks[index] = nil 
	else
		self:RemoveDuplicateTank(name)
	end
end

function mod:ClearAllTanks()   
	for index, name in pairs(db.ora2tanks) do
		self:RemoveTank(index, name)
		self:SendoRA2Message("R "..name)
	end
	db.ora2tanks = {}
end

function mod:BroadcastTanks()   
	for index, name in pairs(db.ora2tanks) do
		self:SendoRA2Message("SET " .. index .. " " .. name)
	end
end

function mod:FormatName(name)
	if name then 
		local _, class = UnitClass(name)
		if class then return mod.Classcolors[class] .. name .. "|r" end
        end
        return "--------------------"
end

function mod:IconAlreadyAssigned(table, icon)
	return table[icon]
end

function mod:ClearAllIcons(table)
	for icon = 1,8 do
		if table[icon] then SetRaidTarget(table[icon], 0) end
	end
end

function mod:CheckIcons()
	if self:TimerNeeded(db.friendlytargets) then
		for icon = 1,8 do
			local unit = db.friendlytargets[icon] 
			if unit and UnitIsVisible(unit) then SetRaidTarget(unit, icon) end
		end
	end
	if self:TimerNeeded(db.hostiletargets) then
		for icon = 1,8 do
			local unit = db.hostiletargets[icon] 
			if unit and UnitIsVisible(unit) then
				local target = unit .. "-target"
				local hastarget = UnitName(target)
				if hastarget and not UnitIsFriend(Player, target) then
					local targeticon = GetRaidTargetIndex(target)
					if targeticon then
						if self:GetPriority(icon) < self:GetPriority(targeticon) then
							SetRaidTarget(target, icon)
						end
					else 
						SetRaidTarget(target, icon)
					end
				end
			end
		end
	end
end
		
function mod:GetPriority(icon)
	for i = 1,8 do
		if db.iconpriority[i] == icon then return i end
	end
end

function mod:SendoRA2Message(msg)
	self:debug("Sending to oRA2...."..msg)
	SendAddonMessage("CTRA", msg, "RAID")
end
